/*
 * Program: ThrottleSafe (Gassicher oder frei übersetzt: Idiotensichere/Narrensichere Gasfunktion)
 * Version: 1
 * Date: 160709
 * Author : Jennifer Sirtl
 * HW-Platform: Arduino Pro Mini
 * Schematic, wireing, code and informations on http://www.mostfun.de (searchfield input: TrottleSafe)
 *
 * Purpose of Program:
 *
 * Realise a safe function of trottle/gas-lock
 * After switch-on the transmitter the lock function is active, green LED lights.
 * To unlock the trottle-function (2 channels are supported: normal throttle and switch-trottle for sailing-planes with e-motor), push the button 2 Seconds. 
 * Shorter pushing the button doesn´t unlock the trottle. Also is one of the supervises trottle-channels are not low, unlock is not done.
 * After unlock, red LED lights, all functions are ready to run. 
 * To lock after flight or if something happens, push the Button again (short or long, doesn´t matter. 
 * This Program supports all potentiometer-driven transmitters. Incremental-sensors are not supported.
 * 
 *
 * Versions:
 *
 * 1 First Version 
  *
 * Known Restrictions:
 *  none
 *
 *   
 * Pinning: see defines
 *
 *
 * Licence: CC-BY-SA
 */

#define SwitchRun 12
#define SwitchSafe 10
#define Sense1 A0
#define Sense2 A1
#define Taster 9
#define LEDrt 13
#define LEDgn 11
 
#define LoopMax 800

double n;
float ChThreshold=100;

void setup() {
  digitalWrite(SwitchRun, LOW);
  pinMode(SwitchRun, OUTPUT);

  digitalWrite(SwitchSafe, HIGH);
  pinMode(SwitchSafe, OUTPUT);
  
  pinMode(LEDrt, OUTPUT);
  digitalWrite(LEDgn, HIGH);

  pinMode(LEDgn, OUTPUT);
  digitalWrite(LEDrt, LOW);

  pinMode(Taster, INPUT_PULLUP);
}

void loop() 
{
    n=0;
    
    if (digitalRead(Taster)==0)
    {
      while ((digitalRead(Taster)==0) && (n<LoopMax))
      {
        n++;
        delay(1);
      }
      if (n>=LoopMax)
      {
        
        if ( (analogRead(Sense1)<=ChThreshold) & (analogRead(Sense2)<=ChThreshold) )
        //if ( (analogRead(Sense2)<=ChThreshold)  )
        {
          n=0;
          //Serial.println("S2R");
          switchSafe2Run();
          while(digitalRead(Taster)==0)
          {
            delay(10);
          }
        }
      }
      else
      {
        n=0;
        switchRun2Safe();
        //Serial.println("R2S");
      }
    }
}


void switchSafe2Run()
{
  digitalWrite(SwitchSafe, LOW);
  digitalWrite(SwitchRun, HIGH);
  digitalWrite(LEDgn, LOW);
  digitalWrite(LEDrt, HIGH);
}

void switchRun2Safe()
{
  digitalWrite(SwitchRun, LOW);
  digitalWrite(SwitchSafe, HIGH);
  digitalWrite(LEDgn, HIGH);
  digitalWrite(LEDrt, LOW);
}


